function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_maps_page(){
     //检测当前是否maps页面
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('amazon')==-1){
                   chrome.tabs.create({ url: "https://www.amazon.com" });
            }
        }else{
            chrome.tabs.create({ url: "https://www.amazon.com" });
        }
    });
}

/**
 * 字典数组排序，只针对纯英文、数字或纯中文的排序
 * @param: dictArray 需要排序的字典数组
 * @param: sortKey  需要进行排序的键
 * @param: sortType asc升序(默认)  desc 降序
 **/
function util_dictArraySorting(dictArray,sortKey,sortType="asc"){
    if (sortType == 'asc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictA[sortKey] - dictB[sortKey]:dictA[sortKey].localeCompare(dictB[sortKey])
      })
    }
    if (sortType == 'desc'){
      dictArray.sort(function (dictA, dictB){
          console.log(dictA);
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictB[sortKey] - dictA[sortKey]:dictB[sortKey].localeCompare(dictA[sortKey])
      })
    }
    return dictArray
}

function get_expire(){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            console.log('expire_date');
            console.log(expire_date);
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
    });
}

get_expire();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        util_check_is_maps_page();
        //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //
            let export_datas = [];
            //
            let shangjias_data = [];
            for(let key in callback_data){
                if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                    let shangjia_shangjia_item_data = callback_data[key];
                    //if(shangjia_shangjia_item_data['_is_request'] && shangjia_shangjia_item_data['_seller_url_is_request'] && shangjia_shangjia_item_data['_seller_country'] != ''){
                         shangjias_data.push(callback_data[key]);
                    //}
                }
            }
            //
            let shangjias_new_data = util_dictArraySorting(shangjias_data, 'num', 'asc');
            //
            for(let i=0;i<shangjias_new_data.length;i++){
                //
                let shangjia_contact_info = shangjias_new_data[i];
                //
                let export_data_item = {
                    '产品名': shangjia_contact_info['_product_name'],
                    '链接': shangjia_contact_info['_shangjia_item_url'],
                    '上架日期':shangjia_contact_info['_product_add_date'],
                    '售价': shangjia_contact_info['_product_price'],
                    '原价': shangjia_contact_info['_product_old_price'],
                    '评论分值': shangjia_contact_info['_product_review_score'],
                    '评论数': shangjia_contact_info['_product_review_num'],
                    '上月销量': shangjia_contact_info['_product_bought_in_past_month'],
                   // '_product_answered_questions': shangjia_contact_info['_product_answered_questions'],
                    //'_product_brand': shangjia_contact_info['_product_brand'],
                    //'_product_img': shangjia_contact_info['_product_img'],
                    '类目排名':shangjia_contact_info['_product_bestseller_rank_top'],
                    '类目':shangjia_contact_info['_product_bestseller_rank_name'],
                    '类目链接':shangjia_contact_info['_product_bestseller_rank_url'],
                    '发货':shangjia_contact_info['_shipping_from'],
                    '品牌':shangjia_contact_info['_product_brand'],

                    '店铺名':shangjia_contact_info['_store_name'],
                    '店铺链接':shangjia_contact_info['_store_url'],

                    //'_seller_id': shangjia_contact_info['_seller_id'],
                    '卖家名': shangjia_contact_info['_seller_name'],
                    '卖家链接': shangjia_contact_info['_seller_url'],

                    //'_seller_about': shangjia_contact_info['_seller_about'],
                    //'_seller_country': shangjia_contact_info['_seller_country'],
                    //'_seller_detail': shangjia_contact_info['_seller_detail'],
                    //'_seller_phone': shangjia_contact_info['_seller_phone'],

                    '_is_request':shangjia_contact_info['_is_request'] == 2 ? '产品已采集': '产品未采集',
                    //'_seller_url_is_request': shangjia_contact_info['_seller_url_is_request'] == 2 ? '卖家已采集': '卖家未采集',
                    //'_seller_is_repeat': shangjia_contact_info['_seller_is_repeat'] == 1 ? '有重复': '',
                }
                export_datas.push(export_data_item);
            }
            //
            exportToExcel(export_datas, 'gycharm-amz-monitor-export-'+Date.now(), "Sheet1");
            //
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_clean();

function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        util_check_is_maps_page();
        //
        if(confirm("确认清空吗?")){
            var bg = chrome.extension.getBackgroundPage();
            bg.storage_clear();
            //
        }
    });
}

extract_catalog_products_clean();
//
function data_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.get_data_process();
    //
    bg.data_process_get(function (callback_data) {
        //$('#message-info').html('');
        let data_process = callback_data['data_process'];
        let total_add_shangjia_num = 0;
        let has_caiji_shangjia_num = 0;
        if(typeof data_process !== 'undefined' ){
            total_add_shangjia_num = data_process['total_add_shangjia_num'];
            has_caiji_shangjia_num = data_process['has_caiji_shangjia_num'];
            //
            $('#data_process').html("已添加<span>"+total_add_shangjia_num+"</span>个产品,已采集产品<span>"+has_caiji_shangjia_num+"</span>个");
            //
        }
        //
    });
}
data_process();

setInterval(data_process, 3000);
//
function jihuo(){
    $('#jihuo_btn').click(function (){
        util_check_is_maps_page();
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();
//
function init(){
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        //开启采集
        if(callback_data['pause'] == 1){
            $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
        }
        $('#extract-catalog-products-pause').show();
        //自动翻页采集
        if(callback_data['pause_page'] == 1){
            $('#extract-catalog-products-pause-page').text('前台采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause-page').text('前台采集已开启,可点击暂停');
        }
        $('#extract-catalog-products-pause-page').show();
        //
    });
}
init();
//
function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();

//
function extract_catalog_products_pause_page(){
    $('#extract-catalog-products-pause-page').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_page_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_page'] == 1){
                    $('#extract-catalog-products-pause-page').text('前台采集已关闭,可点击开启');
                }else{
                    $('#extract-catalog-products-pause-page').text('前台采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause_page();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.maijia_num)

    if(req.action == 'update-shangjia-num'){
        var catalog_products_num = 0;
        var maijia_num = req.maijia_num;
        $('.catalog-products-num').html(maijia_num);
    }else if(req.action == 'background-tips'){
        //
        $('#message-info').html("<div style='color:red'>"+req.info+"</div>");
        //
         //
        chrome.tabs.create({ url: req.url });
        //
    }

    //sendRes("popup已经收到")

  })
//
//
document.getElementById("opnFacebook").addEventListener('click', function () {
  chrome.tabs.create({ url: "https://www.amazon.com" });
})
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

//
function nav(){
    $('.nav-item').click(function (){
        $('.nav-item').removeClass('active');
        $(this).addClass('active');
        if($(this).attr('id') == 'nav-product-caiji'){
            $('.nav-product-caiji-content').show();
            $('.nav-product-monitor-content').hide();
            $('body').css('height','265px');
        }
        if($(this).attr('id') == 'nav-product-monitor'){
            $('.nav-product-caiji-content').hide();
            $('.nav-product-monitor-content').show();
             $('body').css('height','500px');
        }
    });
}
nav();
//
function monitor_view_close(){
    $('.close').click(function (){
        $('#overlay').hide();
    });
}
monitor_view_close();
//
function monitor_btn_del(_product_asin=''){
    console.log('monitor_btn_del');
   if (window.confirm("确定要删除吗？")) {
       //
       monitor_storage_clear_product(_product_asin);
       //
   }
}

function monitor_btn_view(_product_asin = ''){
    //
    if(_product_asin){
        $('#overlay').show();
        let prefix = 'monitor_product_'+$.md5(_product_asin);
        chrome.storage.local.get(null, function(items) {
            if(items.hasOwnProperty(prefix)) {
                //
                let _product_info = items[prefix];
                let _monitor_data = _product_info['_monitor_data'];
                //
                let _product_review_num_arr = [];
                let _product_answered_questions_arr = [];
                let _product_bought_in_past_month_arr = [];
                let _product_price_arr = [];
                let _bestseller_rank_arr = [];

                let _bestseller_rank_name = '';
                for(let _i=0;_i<_monitor_data.length;_i++){
                    let _date = _monitor_data[_i]['_date'];
                    _date = _date.replaceAll('-','');
                    _date = parseInt(_date) || 0;
                    //
                    let _price = _monitor_data[_i]['_product_price'];
                    if(_price){
                        _price = _price.replace('$','');
                    }
                    //
                    _product_review_num_arr.push({
                        x:_date,
                        y:parseInt(_monitor_data[_i]['_product_review_num']) || 0
                    });
                    _product_answered_questions_arr.push({
                        x:_date,
                        y:parseInt(_monitor_data[_i]['_product_answered_questions']) || 0
                    });
                    _product_bought_in_past_month_arr.push({
                        x:_date,
                        y:parseInt(_monitor_data[_i]['_product_bought_in_past_month']) || 0
                    });
                    _product_price_arr.push({
                        x:_date,
                        y:parseInt(_price) || 0
                    });
                    _bestseller_rank_arr.push({
                        x:_date,
                        y:parseInt(_monitor_data[_i]['_product_bestseller_rank_top'])
                    });
                    //
                    if(_bestseller_rank_name == '' && _monitor_data[_i]['_product_bestseller_rank_name']){
                        _bestseller_rank_name = 'Bestseller rank:'+_monitor_data[_i]['_product_bestseller_rank_name'];
                    }
                    //
                }
                console.log(_product_price_arr);
                let _series = [{
                        name: 'Reviews',
                        data: _product_review_num_arr,
                        id: 'series1',
                        visible: true
                    } ,{
                        name: 'Questions',
                        data: _product_answered_questions_arr,
                        id: 'series2',
                        visible: false
                    },{
                        name: 'Bought',
                        data: _product_bought_in_past_month_arr,
                        id: 'series3',
                        visible: false
                    }, {
                        name: 'Price',
                        data: _product_price_arr,
                        id: 'series4',
                        visible: false
                    }];
                if(_bestseller_rank_name){
                    _series.push({
                        name: _bestseller_rank_name,
                        date: _bestseller_rank_arr,
                        id: 'series5',
                        visible: false
                    });
                }
                //
                var chart =  Highcharts.chart('chartcontainer', {
                     chart: {
                        type: 'spline'
                    },
                    title: {
                        text: '评论、销量、Best Sellers Rank监控曲线图',
                        align: 'left'
                    },

                    subtitle: {
                        text: _product_info['_product_name']+"<a href='"+_product_info['_product_url']+"' target='_blank'>查看listing</a>",
                        align: 'left'
                    },

                    yAxis: {
                        title: {
                            text: '值'
                        }
                    },

                    xAxis: {
                            title: {
                                text: '日期'
                            }
                        },

                    legend: {
                        layout: 'vertical',
                        align: 'right',
                        verticalAlign: 'middle'
                    },

                    /*plotOptions: {
                        series: {
                            label: {
                                connectorAllowed: false
                            },
                            pointStart: 2010
                        }
                    },*/
                    series: _series,
                    responsive: {
                        rules: [{
                            condition: {
                                maxWidth: 600
                            },
                            chartOptions: {
                                chart: {
                                    width: 600
                                },
                                legend: {
                                    layout: 'horizontal',
                                    align: 'center',
                                    verticalAlign: 'bottom'
                                }
                            }
                        }]
                    }
                });
                // 监听点击事件
                // 监听图表的点击事件
                chart.container.addEventListener('click', function (e) {
                    var series1 = chart.get('series1');
                    var series2 = chart.get('series2');
                    var series3 = chart.get('series3');
                    var series4 = chart.get('series4');
                    var series5 = chart.get('series5');
                    // 如果点击的是系列1，禁用系列2，并启用系列1
                    if (e.target.textContent === series1.name) {
                        series1.setVisible(true);
                        series2.setVisible(false);
                        series3.setVisible(false);
                        series4.setVisible(false);
                        series5.setVisible(false);
                    }
                    if (e.target.textContent === series2.name) {
                        series1.setVisible(false);
                        series2.setVisible(true);
                        series3.setVisible(false);
                        series4.setVisible(false);
                        series5.setVisible(false);
                    }
                    if (e.target.textContent === series3.name) {
                        series1.setVisible(false);
                        series2.setVisible(false);
                        series3.setVisible(true);
                        series4.setVisible(false);
                        series5.setVisible(false);
                    }
                    if (e.target.textContent === series4.name) {
                        series1.setVisible(false);
                        series2.setVisible(false);
                        series3.setVisible(false);
                        series4.setVisible(true);
                        series5.setVisible(false);
                    }
                    if (e.target.textContent === series5.name) {
                        series1.setVisible(false);
                        series2.setVisible(false);
                        series3.setVisible(false);
                        series4.setVisible(false);
                        series5.setVisible(true);
                    }
                });
                //
            }
        });
    }
    //
}
/********monitor****************/
function monitor_products_summary_render(_products_summary_all,_sort=''){
    let _html = "<div>";
    _html += "<div class='item-row item-row-head'>";
    _html += "<div class='_product_name'>产品名</div>";
    _html += "<div class='_product_img'>产品图</div>";
    _html += "<div class='_seller_name'>卖家名</div>";
    _html += "<div class='_product_review_num'>评论数<span class='_down' _sort='_product_review_num|_down'>▽</span><span class='_up' _sort='_product_review_num|_up'>△</span></div>";
    //_html += "<div class='_product_answered_questions'>问答数<span class='_down' _sort='_product_answered_questions|_down'>▽</span><span class='_up' _sort='_product_answered_questions|_up'>△</span></div>";
    _html += "<div class='_product_bought_in_past_month'>销量<span class='_down' _sort='_product_bought_in_past_month|_down'>▽</span><span class='_up' _sort='_product_bought_in_past_month|_up'>△</span></div>";
    _html += "<div class='_monitor_day_num' style='text-align: center'>监控天数<span class='_down' _sort='_monitor_day_num|_down'>▽</span><span class='_up' _sort='_monitor_day_num|_up'>△</span></div>";
    _html += "<div class='_add_date' style='text-align: center;'>添加日期<span class='_down' _sort='_add_date|_down'>▽</span><span class='_up' _sort='_add_date|_up'>△</span></div>";
    _html += "<div class='_action' style='text-align: center'>操作</div>";
    _html += "</div>";
    if(_products_summary_all.length > 0){
        //
        if(_sort){
            let _sort_arr = _sort.split('|');
            if(_sort_arr[0] == '_product_review_num'){
                if(_sort_arr[1] == '_down'){
                    _products_summary_all.sort(function(a, b) {
                        return b._last_product_review_num_2 - a._last_product_review_num_2; // 降序排列
                    });
                }else if(_sort_arr[1] == '_up'){
                    _products_summary_all.sort(function(a, b) {
                        return a._last_product_review_num_2 - b._last_product_review_num_2; // 降序排列
                    });
                }
            }else if(_sort_arr[0] == '_product_answered_questions'){
                if(_sort_arr[1] == '_down'){
                    _products_summary_all.sort(function(a, b) {
                        return b._last_product_answered_questions_num - a._last_product_answered_questions_num; // 降序排列
                    });
                }else if(_sort_arr[1] == '_up'){
                    _products_summary_all.sort(function(a, b) {
                        return a._last_product_answered_questions_num - b._last_product_answered_questions_num; // 降序排列
                    });
                }
            }else if(_sort_arr[0] == '_product_bought_in_past_month'){
                if(_sort_arr[1] == '_down'){
                    _products_summary_all.sort(function(a, b) {
                        return b._last_product_bought_in_past_month_num - a._last_product_bought_in_past_month_num; // 降序排列
                    });
                }else if(_sort_arr[1] == '_up'){
                    _products_summary_all.sort(function(a, b) {
                        return a._last_product_bought_in_past_month_num - b._last_product_bought_in_past_month_num; // 降序排列
                    });
                }
            }else if(_sort_arr[0] == '_monitor_day_num'){
                if(_sort_arr[1] == '_down'){
                    _products_summary_all.sort(function(a, b) {
                        return b._monitor_day_num - a._monitor_day_num; // 降序排列
                    });
                }else if(_sort_arr[1] == '_up'){
                    _products_summary_all.sort(function(a, b) {
                        return a._monitor_day_num - b._monitor_day_num; // 降序排列
                    });
                }
            }else if(_sort_arr[0] == '_add_date'){
                if(_sort_arr[1] == '_down'){
                    _products_summary_all.sort(function(a, b) {
                        return b._add_date_int - a._add_date_int; // 降序排列
                    });
                }else if(_sort_arr[1] == '_up'){
                    _products_summary_all.sort(function(a, b) {
                        return a._add_date_int - b._add_date_int; // 降序排列
                    });
                }
            }
        }else{
            _products_summary_all.sort(function(a, b) {
                return b._num - a._num; // 降序排列
            });
        }


        for(let _i=0;_i<_products_summary_all.length;_i++){
            _html += "<div class='item-row' style='display: flex;flex-wrap: nowrap;justify-content: flex-start;'>";
            _html += "<input type='hidden' name='_product_asin' value='"+_products_summary_all[_i]['_product_asin']+"'/>";
            let _product_name = _products_summary_all[_i]['_product_name'];
            _product_name = _product_name.substring(0,10);
            _html += "<div class='_product_name'><a title='"+_products_summary_all[_i]['_product_name']+"' href='"+_products_summary_all[_i]['_product_url']+"' target='_blank'>"+_product_name+'...'+"</a></div>";
            _html += "<div class='_product_img' style='text-align: center'><a href='"+_products_summary_all[_i]['_product_url']+"' target='_blank' title='"+_products_summary_all[_i]['_product_name']+"'><img src='"+_products_summary_all[_i]['_product_img']+"' width='25px;'/></a></div>";
            _html += "<div class='_seller_name' style='text-align: left'><a href='"+_products_summary_all[_i]['_seller_url']+"' target='_blank'>"+_products_summary_all[_i]['_seller_name']+"</a></div>";
            _html += "<div class='_product_review_num' style='text-align: center'>"+_products_summary_all[_i]['_last_product_review_num']+"</div>";
            //_html += "<div class='_product_answered_questions' style='text-align: center'>"+_products_summary_all[_i]['_last_product_answered_questions']+"</div>";
            _html += "<div class='_product_bought_in_past_month' style='text-align: center'>"+_products_summary_all[_i]['_last_product_bought_in_past_month']+"</div>";
            _html += "<div class='_monitor_day_num' style='text-align: center'>"+_products_summary_all[_i]['_monitor_day_num']+"</div>";
            _html += "<div class='_add_date' style='text-align: center'>"+_products_summary_all[_i]['_add_date']+"</div>";
            _html += '<div class="_action" style=\'text-align: center\'>' +
                '<div style="height: 25px;line-height: 25px;margin-bottom: 3px;"><button class="_btn _btn_view" _product_asin="'+_products_summary_all[_i]['_product_asin']+'">查看</button></div>' +
                '<div style="height: 25px;line-height: 25px;"><button class="_btn _btn_del" _product_asin="'+_products_summary_all[_i]['_product_asin']+'">删除</button></div>' +
                '</div>';
            _html += "</div>";
        }
    }else{
        _html += "<div>无</div>";
    }

    _html+="</div>";
    $('.product-monitor-content-box-1').html(_html).find('._btn_del').click(function (){
        let _product_asin = $(this).attr('_product_asin');
        monitor_btn_del(_product_asin);
    });
    $('.product-monitor-content-box-1').find('._down,._up').click(function (){
        let _sort = $(this).attr('_sort');
        mointor_get_products_summary_all(_sort);
    });
    //
    $('.product-monitor-content-box-1').find('._btn_view').click(function (){
       let _product_asin = $(this).attr('_product_asin');
       monitor_btn_view(_product_asin);
    });
}

function mointor_get_products_summary_all(_sort=''){
    let _products_summary_all = [];
    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('monitor_product_') != -1){

                let _last_product_review_num_is_grow = '';
                let _last_product_answered_questions_is_grow = '';
                let _last_product_bought_in_past_month_is_grow = '';

                let _last_product_review_num = 0;
                let _last_product_answered_questions = 0;
                let _last_product_bought_in_past_month = 0;

                if(items[key]['_monitor_data'].length > 0){
                    _last_product_review_num = items[key]['_monitor_data'][items[key]['_monitor_data'].length-1]['_product_review_num'];

                    _last_product_answered_questions = items[key]['_monitor_data'][items[key]['_monitor_data'].length-1]['_product_answered_questions'];
                    _last_product_bought_in_past_month = items[key]['_monitor_data'][items[key]['_monitor_data'].length-1]['_product_bought_in_past_month'];
                    if(items[key]['_monitor_data'].length > 1){
                       let _last_d2_product_review_num = items[key]['_monitor_data'][items[key]['_monitor_data'].length-2]['_product_review_num'];
                       if(_last_product_review_num > _last_d2_product_review_num){
                           _last_product_review_num_is_grow = '↑';
                       }
                       //
                       let _last_d2_product_answered_questions = items[key]['_monitor_data'][items[key]['_monitor_data'].length-2]['_product_answered_questions'];
                       if(_last_product_answered_questions > _last_d2_product_answered_questions){
                           _last_product_answered_questions_is_grow = '↑';
                       }
                       //
                       let _last_d2_product_bought_in_past_month = items[key]['_monitor_data'][items[key]['_monitor_data'].length-2]['_product_bought_in_past_month'];
                       if(_last_product_bought_in_past_month > _last_d2_product_bought_in_past_month){
                           _last_product_bought_in_past_month_is_grow = '↑';
                       }
                        //
                    }
                }
                let _last_product_bought_in_past_month_num = _last_product_bought_in_past_month;
                if(_last_product_bought_in_past_month_num){
                     _last_product_bought_in_past_month_num = _last_product_bought_in_past_month_num.replace('+','');
                    if(_last_product_bought_in_past_month_num.indexOf('K') !=-1){
                        _last_product_bought_in_past_month_num = _last_product_bought_in_past_month_num.replace('K','');
                        _last_product_bought_in_past_month_num = parseInt(_last_product_bought_in_past_month) || 0;
                    }
                }

                let _add_date = items[key]['_add_date'];
                _add_date = _add_date.replaceAll('-','');
                let _add_date_int = parseInt(_add_date) || 0;

                _products_summary_all.push({
                    '_product_name': items[key]['_product_name'],
                    '_product_url': items[key]['_product_url'],
                    '_product_asin': items[key]['_product_asin'],
                    '_product_img': items[key]['_product_img'],
                    '_add_date': items[key]['_add_date'],
                    '_add_date_int': _add_date_int,
                    //
                    //'_store_name': items[key]['_store_name'],
                   // '_store_url': items[key]['_store_url'],
                    //
                     '_seller_name':items[key]['_seller_name'],
                     '_seller_url':items[key]['_seller_url'],
                    //
                    '_monitor_day_num': items[key]['_monitor_data'].length,
                    '_last_product_review_num':_last_product_review_num+_last_product_review_num_is_grow,
                    '_last_product_review_num_2':parseInt(_last_product_review_num) || 0,

                    '_last_product_answered_questions':_last_product_answered_questions+_last_product_answered_questions_is_grow,
                    '_last_product_answered_questions_num':parseInt(_last_product_answered_questions) || 0,

                    '_last_product_bought_in_past_month': _last_product_bought_in_past_month+_last_product_bought_in_past_month_is_grow,
                    '_last_product_bought_in_past_month_num': _last_product_bought_in_past_month_num,
                    //
                    '_num':items[key]['num'],
                    '_last_request_date':items[key]['_last_request_date'],
                    //
                });
            }
        }
        //
        console.log('_products_summary_all');
        console.log(_products_summary_all);
        monitor_products_summary_render(_products_summary_all, _sort);
        //
    });
}
mointor_get_products_summary_all();

function monitor_storage_clear_product(_product_asin=''){
    if(_product_asin){
        let prefix = 'monitor_product_'+$.md5(_product_asin);
        chrome.storage.local.get(null, function(items) {
            if(items.hasOwnProperty(prefix)) {
                chrome.storage.local.remove(prefix, function () {
                    console.log(`键名 ${prefix} 的值已被清空！`);
                    $('#message-info').html("<div class='alert-info'>删除成功!</div>");
                    //
                    mointor_get_products_summary_all();
                    //
                });
            }
        });
    }
}

